
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
using namespace std;

extern "C"{
#include <unistd.h>
}

#include "K5VSSP_Header.hpp"

char *me;
void usage(){
  printf("Usage: %s -f <k5vssp file>\n",me);
  exit(1);
}

int main (int argc, char * const argv[]) {
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  
  if(argc < 3) usage() ;
  string fname;
  int k=0; 

  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hf:")) { 
    case 'h':   usage();     break;
      //    case 'e':    break;
    case 'f':   fname = optarg;      break;
    case '?':    usage(); break;
    }
  }

  if(fname.empty()){
    cerr << "Error: missing fname\n";
    usage();
  }
  
  FILE *fp = fopen(fname.c_str(),"r");
  if(fp ==NULL){
    cerr << "Error: Failed to open file(" << fname << ")\n";
    exit(1);
  }
  
  K5VSSP32_Hdr *pk5hdr32(0), k5hdr32;
  K5VSSP_Hdr *pk5hdr(0), k5hdr;
  int offset(0);
  int headsize = pk5hdr32->Headsize();

  pk5hdr32 = K5VSSP32_Hdr_find(fp,offset);
  while(pk5hdr32 !=0){
    fprintf(stderr,"Hdr offset(%d) ",offset);
    switch(pk5hdr32->HD_Match()){
    case 2: // VSSP32
      k5hdr32 = *pk5hdr32;
      k5hdr32.Print_hd(stderr);
      break;
    case 1: // VSSP
      pk5hdr = (K5VSSP_Hdr*)pk5hdr32;
      k5hdr = *pk5hdr;
      k5hdr.Print_hd(stderr);
      break;
    }
    //    putc('\n',stderr);
    fseek(fp,headsize,SEEK_CUR);
    pk5hdr32 = K5VSSP32_Hdr_find(fp,offset);
  }
  
  fclose(fp);

}
