
/** @file test_Mk5B is test reading Mk5B data 
 *  @author M.Sekido
 *  @Date 2009.4.6
 */

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include "Mk5B_Header.hpp"
using namespace std;

char *me;

void usage(){
  cerr << "Usage: " << me << " -f <filename> \n";
  //  cerr << "  -d <n>: Deltailed output level (default: 0)\n";
  exit(1);
}

int main(int argc, char *argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */
  int k=0;
  string fname;
  Mk5B_Hdr   mk5b_hdr;

  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hf:")) { 
    case 'h':  usage(); break;
    case 'f': fname = optarg; break;
      //    case 'd': mk5b_hdr.Set_dbg(atoi(optarg)); break;
    case '?' : /* Error:  character not in list */ 
      fprintf(stderr, /* Yes */ 
	      "%s WARNING:  Unknown option on command line \n", me); 
      break; 
    case ':' : /* Error:  missing parameter */ 
      fprintf(stderr, "%s WARNING:  Missing number on command line \n", me); 
      usage();
      break; 
    }
  }

  if(fname.empty()) usage();
  
//   const int bsize = 32000;
//   vector <uint8_t> buf(bsize);
  
//  cerr << "size of buf=" << buf.size() << endl;

  FILE *fp = fopen(fname.c_str(),"r");
  if(fp ==NULL){
    cerr << "Error inn opening file: " << fname << endl;
    exit(1);
  }
  
  fprintf(stderr, "Mk5B headsize=%d\n", mk5b_hdr.Headsize());

  Mk5B_Hdr *pm5hdr(0), m5hdr;
  int offset(0);
  
  pm5hdr = Mk5B_Hdr_find(fp,offset);
  while(pm5hdr !=0){
    m5hdr = *pm5hdr;
    fprintf(stderr,"Hdr offset(%d) ",offset);
    m5hdr.Print_hd(stderr);
    //    putc('\n',stderr);
    pm5hdr = Mk5B_Hdr_find(fp,offset);
  }
  fclose(fp);

}

